SystemOrganization addCategory: #'SimpleApplescript-Core'!

Object subclass: #Applescript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Core'!

!Applescript commentStamp: 'SeanDeNigris 12/6/2011 09:55' prior: 0!
I execute Applescript scripts via my class side #doIt:.

I am a bare-bones replacement for the class of the same name in the Applescript project (on Squeaksource) because the required plugin does not work on the new Cocoa Cog VMs.!

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 3/27/2012 10:07'!
asOldManSay: aString
	"self asOldManSay: 'you damn kids get off my lawn'"

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Bahh"'.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 3/14/2012 19:23'!
asYoungGirlSay: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Princess"'.! !

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 8/6/2012 16:37'!
doIt: aString 

	| output |
	output := OsaScript run: aString.
	^ self smalltalkifyOutput: output.
! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 1/6/2012 11:38'!
escapeDoubleQuotesIn: aString
	"Should be in String, but this is all very experimental, so I'm keeping it contained"

	^ aString copyReplaceAll: '"' with: '\"' asTokens: false.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/24/2012 16:19'!
escapeTabsIn: aString 

	^ aString copyWithout: Character tab.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/24/2012 16:37'!
makeSafeForMultiline: aString

	| tabsEscaped |
	tabsEscaped := self escapeTabsIn: aString.
	^ self escapeDoubleQuotesIn: tabsEscaped.! !

!Applescript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 2/16/2012 21:56'!
say: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/6/2012 12:55'!
smalltalkifyOutput: aString 

	aString = 'true' ifTrue: [ ^ true ].
	aString = 'false' ifTrue: [ ^ false ].
	^ aString.! !

Object subclass: #OsaScript
	instanceVariableNames: 'recompilableOutput scriptSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Core'!

!OsaScript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:02'!
run: aString

	| command |
	command := self new
		script: aString;
		recompilableOutput.
	^ command run.! !

!OsaScript methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:13'!
initialize

	super initialize.
	recompilableOutput := false.! !

!OsaScript methodsFor: 'configuration' stamp: 'SeanDeNigris 8/6/2012 16:12'!
recompilableOutput

	recompilableOutput := true.! !

!OsaScript methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:10'!
run

	| process commandTemplate flags commandString |
	commandTemplate := '/usr/bin/osascript {1} <<END_S
{2}
END_S'.
	flags := recompilableOutput
		ifTrue: [ '-ss' ]
		ifFalse: [ '' ].
	commandString := commandTemplate format: { flags. scriptSource }.
	commandString := commandString copyReplaceAll: Character cr asString with: Character lf asString.
	process := PipeableOSProcess waitForCommand: commandString.
	process succeeded ifFalse: [ self error: process errorUpToEndOfFile ].
	process close; closePipes.
	^ process output trimRight.
! !

!OsaScript methodsFor: 'accessing' stamp: 'SeanDeNigris 8/6/2012 16:12'!
script: aString 

	scriptSource := aString.! !
